<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- icon-top-onScroll -->
    <v-btn v-scroll="onScroll" v-show="fab" fab dark fixed bottom right color="#428bca" @click="toTop">
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <!-- icon-top-onScroll -->

    <!-- table admin oneid -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title><h1>Admin OneID</h1></v-card-title>
                <div>
                  <v-card-title>
                    <v-btn
                      class="mr-1"
                      @click="dialog_add_admin_oneid = true"
                      type="button"
                      color="#428bca"
                      small
                      dark
                    >
                      <v-icon small class="pr-1">mdi-account-plus</v-icon>
                      Add admin oneid
                    </v-btn>
                    <v-btn
                      @click="delete_user"
                      type="button"
                      color="error"
                      small
                      :disabled="disble_delete"
                    >
                      <v-icon small class="pr-1">mdi-delete</v-icon>
                      Delete User
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <v-data-table
                    v-model="selected"
                    :headers="headers"
                    :items="all_admin"
                    :search="search"
                    :single-select="singleSelect"
                    show-select
                    item-key="name"
                  >
                    <template v-slot:item.actions="{ item }">
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="edit_add_admin_oneid(item)"
                            color="teal"
                          >
                            mdi-pencil
                          </v-icon>
                        </template>
                        <span>Edit</span>
                      </v-tooltip>
                    </template>
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table announcement -->

    <!-- dialog_add_admin_oneid -->
    <v-dialog v-model="dialog_add_admin_oneid" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color:white;background:#428bca">
          Add Admin OneID
        </v-card-title>
        <v-form ref="form_add_admin_oneid">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    :rules="user_oneIDRules"
                    label="User OneID"
                    outlined
                    dense
                    v-model="form_add_admin_oneid.oneid"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pb-0">
                  <v-text-field
                    :rules="nameRules"
                    label="Name"
                    outlined
                    dense
                    v-model="form_add_admin_oneid.name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pb-0">
                  <v-text-field
                    :rules="surnameRules"
                    label="Surname"
                    outlined
                    dense
                    v-model="form_add_admin_oneid.surname"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    :rules="nicknameRules"
                    label="Nickname"
                    outlined
                    dense
                    v-model="form_add_admin_oneid.nickname"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_add" style="color: white;">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_add" style="color: white;">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_add_admin_oneid -->

    <!-- dialog_edit_admin_oneid -->
    <v-dialog v-model="dialog_edit_admin_oneid" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color:white;background:#428bca">
          Edit Admin OneID
        </v-card-title>
        <v-form ref="form_edit_admin_oneid">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    :rules="user_oneIDRules"
                    label="User OneID"
                    outlined
                    dense
                    v-model="form_edit_admin_oneid.oneid"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pb-0">
                  <v-text-field
                    :rules="nameRules"
                    label="Name"
                    outlined
                    dense
                    v-model="form_edit_admin_oneid.name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pb-0">
                  <v-text-field
                    :rules="surnameRules"
                    label="Surname"
                    outlined
                    dense
                    v-model="form_edit_admin_oneid.surname"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    :rules="nicknameRules"
                    label="Nickname"
                    outlined
                    dense
                    v-model="form_edit_admin_oneid.nickname"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancle_edit" style="color: white;">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_edit" style="color: white;">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_add_announcement -->
  </v-app>
</template>

<script>
export default {
  data() {
    return {
      api: process.env.VUE_APP_API,
      session_id: this.$cookies.get("info_login").session_id,
      disble_delete: true,
      singleSelect: false,
      search: "",
      fab: false,
      dialog_loader: false,
      dialog_add_admin_oneid: false,
      form_add_admin_oneid: {},
      dialog_edit_admin_oneid: false,
      form_edit_admin_oneid: {},
      all_admin: [],
      selected: [],
      headers: [
        {
          text: "oneid",
          align: "start",
          value: "oneid",
          sortable: false,
        },
        {
          text: "name",
          align: "start",
          value: "name",
          sortable: false,
        },
        {
          text: "surname",
          align: "start",
          value: "surname",
          sortable: false,
        },
        {
          text: "nickname",
          align: "start",
          value: "nickname",
          sortable: false,
        },

        { text: "Action", value: "actions", sortable: false },
      ],
      // rules
      user_oneIDRules: [(v) => !!v || "Please enter user oneID"],
      nameRules: [(v) => !!v || "Please enter name"],
      surnameRules: [(v) => !!v || "Please enter surname"],
      nicknameRules: [(v) => !!v || "Please enter nickname"],
    };
  },

  watch: {
    selected(val) {
      console.log(val);
      if (val.length == 0) {
        this.disble_delete = true;
      } else {
        this.disble_delete = false;
      }
    },
  },

  mounted() {
    console.log("api -->", this.api);
    this.get_user_admin();
  },

  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    get_user_admin() {
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/oneid_admin", {
          params: {
            token: this.$cookies.get("info_login").token,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          console.log("response", response);
          this.all_admin = response.data.data;
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    delete_user() {
      console.log(this.selected);
      const one_id_array = [];
      for (let index = 0; index < this.selected.length; index++) {
        one_id_array.push(this.selected[index].oneidadmin_id);
      }
      this.$swal({
        title: "Are you sure?",
        text: "You want to delete user!",
        icon: "warning",
        showCancelButton: true,
        allowOutsideClick: false,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes",
      }).then((result) => {
        if (result.value) {
          this.axios
            .delete(
              process.env.VUE_APP_API +
                "/api/v3/oneid_admin?oneidadmin_id=" +
                one_id_array +
                "&userlog_id=" +
                this.$cookies.get("info_login").user_id,
              {
                headers: {
                  Authorization: this.session_id,
                },
              }
            )
            .then((response) => {
              console.log(response.data);
              console.log(response.data.status);
              if (response.data.status == "fail") {
                this.$swal({
                  icon: "error",
                  title: "Error!",
                  text: "package is using.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_user_admin();
                });
              } else {
                this.$swal({
                  icon: "success",
                  title: "Success!",
                  text: "Delete Admin success.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_user_admin();
                });
              }
            })
            .catch((error) => {
              this.dialog_loader = false;
              console.log("error", error);
              this.$swal({
                icon: "error",
                title: "Error!",
                text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
                confirmButtonText: "OK",
                allowOutsideClick: false,
              }).then(() => {
                window.location.href = this.api;
              });
            });
        }
      });
    },

    save_add() {
      if (!this.$refs.form_add_admin_oneid.validate()) return;
      this.dialog_loader = true;
      this.form_add_admin_oneid.userlog_id = this.$cookies.get("info_login").user_id;
      this.form_add_admin_oneid.token = this.$cookies.get("info_login").token;
      this.axios
        .post(
          process.env.VUE_APP_API + "/api/v3/oneid_admin",
          this.form_add_admin_oneid,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then((response) => {
          console.log("response", response);
          this.dialog_loader = false;
          this.dialog_add_admin_oneid = false;
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Add admin oneID success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.get_user_admin();
            this.$refs.form_add_admin_oneid.reset();
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    cancel_add() {
      this.$refs.form_add_admin_oneid.reset();
      this.dialog_add_admin_oneid = false;
      this.get_user_admin();
    },

    edit_add_admin_oneid(item) {
      this.form_edit_admin_oneid = item;
      this.dialog_edit_admin_oneid = true;
    },

    cancle_edit() {
      this.dialog_edit_admin_oneid = false;
      this.get_user_admin();
    },

    save_edit() {
      if (!this.$refs.form_edit_admin_oneid.validate()) return;
      this.dialog_loader = true;
      this.dialog_edit_admin_oneid = false;
      this.form_edit_admin_oneid.oneidadmin_id == this.form_edit_admin_oneid.oneidadmin_id;
      this.form_edit_admin_oneid.userlog_id = this.$cookies.get("info_login").user_id;
      this.form_edit_admin_oneid.token = this.$cookies.get("info_login").token;
      this.axios
        .put(
          process.env.VUE_APP_API + "/api/v3/oneid_admin",
          this.form_edit_admin_oneid,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then((response) => {
          console.log("response", response.data.data);
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Edit Admin OneID success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.dialog_loader = false;
            this.get_user_admin();
            this.$refs.form_edit_admin_oneid.reset();
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },
  },
};
</script>

<style></style>
